module Phylo.Isoline where

import Graphics.D3.Base
import Prelude

import DOM.Simple.Element as DSE
import DOM.Simple.Console (log, log2)
import Data.Array (length)
import Data.Int (toNumber, round)
import Data.Maybe (Maybe(..), fromMaybe, maybe)
import Data.Nullable (null, toMaybe)
import Effect.Aff (Aff, launchAff_)
import FFI.Simple (delay)
import Graphics.D3.Contour as Contour
import Graphics.D3.Selection as Selection
import Phylo.TypesExample as PTE
import Reactix as R
import Reactix.DOM.HTML as H
import Toestand as T

type Isoline = (branches :: Array Int)

--getObjects mBjson = launchAff_ do
--  case mBjson of
--    Just json -> pure $ json.objects

isolineR :: R.Element
isolineR = isoline {branches:[10,20,30]}

isoline :: Record Isoline -> R.Element
isoline props = R.createElement isolineCpt props []

isolineCpt :: R.Component Isoline
isolineCpt = R.hooksComponent "isoline" cpt where
  cpt {} _ = do
    containerRef <- R.useRef null

    R.useEffect' $ do
      
      delay unit $ \_ -> do
        let mContainer = toMaybe $ R.readRef containerRef
        case mContainer of
          Nothing -> pure unit
          Just cr -> do
            _ <- Selection.rootSelectEl cr
            >>= DSE.boundingRect cr    
            pure unit
    pure $ H.div {id:"phyloIsoline", ref: containerRef}[H.text "Isoline"]
--      pure $ H.div {className:"phyloIsoline"}[H.text "Here lies the isoline"]

--drawIsoline :: Array PhyloObject -> Effect Unit
--drawIsoline branches = do
--    div <- rootSelectEl' "phyloIsoline"
--        >>= boundingRect div
--        >>= 
--    density <- Contour.contourDensity
--        >>= Contour.x (\b -> b.x)
--        >>= Contour.y (\b -> b.y)
--        >>= Contour.size([width, height])
--        >>= Contour.thresholds $ round $ length branches / 2
--
--rootSelectEl' :: Element -> D3Eff (Selection DOMrect)
--rootSelectEl' = ffi ["node", ""] "d3.select(node)"